﻿//////////////////////////////////////////////
// QuaternionWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkGraphicsWrap
{
	class DLL_ASTRAEUS_EXPORT QuaternionWrapper final
	{
		private :

			// Constructeur, destructeur
			QuaternionWrapper () = delete ;
			~QuaternionWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Construction / destruction
			static void* constructor (const nkScripts::DataStack& stack) ;
			static void destructor (void* toDestroy) ;
			// Getters
			static nkScripts::OutputValue getX (void* vector) ;
			static nkScripts::OutputValue getY (void* vector) ;
			static nkScripts::OutputValue getZ (void* vector) ;
			static nkScripts::OutputValue getW (void* vector) ;
			// Setters
			static void setX (const nkScripts::DataStack& stack) ;
			static void setY (const nkScripts::DataStack& stack) ;
			static void setZ (const nkScripts::DataStack& stack) ;
			static void setW (const nkScripts::DataStack& stack) ;
			// Applications
			static nkScripts::OutputValue applyToVec (const nkScripts::DataStack& stack) ;
			// Conversion
			static nkScripts::OutputValue setFromAxisAngle (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue setFromEuler (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue toString (const nkScripts::DataStack& stack) ;
	} ;
}