﻿//////////////////////////////////////////////
// Color.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Color final
	{
		public :

			unsigned char _r ;
			unsigned char _g ;
			unsigned char _b ;

		public :

			// Constructeur, destructeur
			Color () ;
			Color (unsigned char red, unsigned char green, unsigned char blue) ;
			~Color () ;

			// Manipulations couleurs
			// Multiplie par le facteur donné si la luminosité n'est pas trop grande
			Color getAssociateColor (float factor = 1.5f) const ;
			// Mix par un facteur avec une autre couleur
			Color mix (const Color& other, float factor) const ;
			// Eclaircissement par layering
			Color getColorForDepth (unsigned int depth) const ;

			// Surcharges opérateurs
			Color operator* (float factor) const ;
	} ;
}