﻿//////////////////////////////////////////////
// DataAllocator.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	// Components
	class Button ;
	class CheckBox ;
	class ComboBox ;

	class ContextMenu ;
	class EditBox ;
	class FileExplorer ;

	class GraphicsWindow ;
	class GroupBox ;
	class ListBox ;

	class LogWin ;
	class MenuBar ;
	class MultiLineEdit ;

	class Popup ;
	class ProgressBar ;
	class ScrollBar ;

	class Slider ;
	class Static ;
	class TabWindow ;

	class TreeView ;
	class Window ;

	// Cursors
	class Cursor ;
}

/// Class ------------------------------------

namespace nkWinUi
{
	class DataAllocator
	{
		public :

			// Constructeur, destructeur
			DataAllocator () ;
			virtual ~DataAllocator () ;

			// Allocations
			// Components
			virtual Button* allocateButton () const = 0 ;
			virtual CheckBox* allocateCheckBox () const = 0 ;
			virtual ComboBox* allocateComboBox () const = 0 ;

			virtual ContextMenu* allocateContextMenu () const = 0 ;
			virtual EditBox* allocateEditBox () const = 0 ;
			virtual FileExplorer* allocateFileExplorer () const = 0 ;

			virtual GraphicsWindow* allocateGraphicsWindow () const = 0 ;
			virtual GroupBox* allocateGroupBox () const = 0 ;
			virtual ListBox* allocateListBox () const = 0 ;

			virtual LogWin* allocateLogWin () const = 0 ;
			virtual MenuBar* allocateMenuBar () const = 0 ;
			virtual MultiLineEdit* allocateMultiLineEdit () const = 0 ;

			virtual Popup* allocatePopup () const = 0 ;
			virtual ProgressBar* allocateProgressBar () const = 0 ;
			virtual ScrollBar* allocateScrollBar () const = 0 ;

			virtual Slider* allocateSlider () const = 0 ;
			virtual Static* allocateStatic () const = 0 ;
			virtual TabWindow* allocateTabWindow () const = 0 ;

			virtual TreeView* allocateTreeView () const = 0 ;
			virtual Window* allocateWindow () const = 0 ;

			// Cursors
			virtual Cursor* allocateCursor () const = 0 ;
	} ;
}